package org.bss.esb.management;

import java.io.Serializable;
import javax.management.MBeanException;

/**
 * The MBean interface for monitoring the {@link org.bss.esb.EsbRouter}.
 * 
 * @version 1.0
 * @author Balwinder Sodhi
 * @see org.bss.esb.EsbRouter
 */
public interface EsbRouterMonitorMBean extends Serializable {
    
    /**
     * @see {@link org.bss.esb.EsbRouter#getMessageCount()}
     */
    int getMessageCount();

    /**
     * @see {@link org.bss.esb.EsbRouter#getLowestTime()}
     */
    long getLowestTime();

    /**
     * @see {@link org.bss.esb.EsbRouter#getHighestTime()}
     */
    long getHighestTime();

    /**
     * @see {@link org.bss.esb.EsbRouter#resetTimings()}
     */
    void resetTimings();

    /**
     * @see {@link org.bss.esb.EsbRouter#updateRoutingTable()}
     */
    void updateRoutingTable() throws MBeanException;

    /**
     * @see {@link org.bss.esb.EsbRouter#getRoutingTableLocation()}
     */
    String getRoutingTableLocation();

    /**
     * @see {@link org.bss.esb.EsbRouter#setRoutingTableLocation(String)}
     */
    void setRoutingTableLocation(String path);

    /**
     * Unregister the MBean.
     */
    void unregister();
}
