package org.bss.esb.management;

import org.bss.esb.EsbRouter;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * Factory for creating the MBeans required/used by the ESB application.
 * 
 * @version 1.0
 * @author Balwinder Sodhi
 */
public class MBeanFactory { 
    
    /**
     * Returns a new instance of the {@link EsbRouterMonitor} MBean.
     * 
     * @param router The EsbRouter instance that will be managed by this MBean
     * @param ic The JNDI initial naming context.
     * @exception NamingException
     */
    public static EsbRouterMonitorMBean getEsbRouterMonitorMBean(
            EsbRouter router, InitialContext ic) throws NamingException {
                
        return new EsbRouterMonitor(router, ic);
        
    }
} 
