package org.bss.esb.management;

import java.io.Serializable;

/**
 * MBean interface for managing the {@link org.bss.esb.redelivery.RedeliveryScheduler} instance.
 * 
 * @version 1.0
 * @author Balwinder Sodhi
 * @see org.bss.esb.redelivery.RedeliveryScheduler
 */
public interface RedeliverySchedulerMonitorMBean extends Serializable {
    
    /**
     * Stops the {@link org.bss.esb.redelivery.RedeliveryScheduler} instance managed by this MBean.
     * @see {@link org.bss.esb.redelivery.RedeliveryScheduler#stopRedeliveryScheduler()}
     */
    void stopRedeliveryScheduler();

    /**
     * Resets the {@link org.bss.esb.redelivery.RedeliveryScheduler} instance managed by this MBean.
     * @see {@link org.bss.esb.redelivery.RedeliveryScheduler#resetRedeliveryScheduler()}
     */
    void resetRedeliveryScheduler();     
} 
