package org.bss.esb.transform;

/**
 * This class implements the identity transform i.e. it simply returns the
 * same message that is supplied to it as the input.
 *
 * @author Balwinder Sodhi
 * @version Jul 10, 2005
 */
public class CustomTransform implements TransformHandler {

    private String configFileUrl;
    /**
     * Transforms the message. The implementation class should be able to
     * handle the passed in message. This method should be invoked only after
     * this <code>TransformHandler</code> instance has been initialized.
     *
     * @param message The message to be transformed.
     * @throws TransformException
     *          Thrown if the handler fails to transform
     *          the passed in message.
     */
    public Object transformMessage(Object message) throws TransformException {
        return message;
    }

    /**
     * Returns the URL of the configuration file backing this
     * transformation class.
     * @return
     */
    public String getConfigFileUrl() {
        return configFileUrl;
    }

    /**
     * Sets the URL for the configuration file backing this
     * transformation class.
     * @param configFileUrl
     */
    public void setConfigFileUrl(String configFileUrl) {
        this.configFileUrl = configFileUrl;
    }
}
