package org.bss.esb.transform;

import java.io.Serializable;

/**
 *
 * @version 1.0
 * @author Balwinder Sodhi
 */
public interface TransformHandler extends Serializable {
    
    /**
     * Transforms the message. The implementation class should be able to
     * handle the passed in message. This method should be invoked only after
     * this <code>TransformHandler</code> instance has been initialized.
     * 
     * @param message The message to be transformed.
     * @exception TransformException Thrown if the handler fails to transform
     * the passed in message. 
     */
    Object transformMessage(Object message) throws TransformException;
        
}
