package org.bss.esb.transport.webservice;

import org.bss.esb.transport.TransportException;
import org.bss.esb.transport.TransportHandler;
import org.bss.esb.util.JmsUtil;

import javax.jms.*;
import javax.naming.NamingException;
import java.util.logging.Logger;

public class WebServiceHandler implements TransportHandler {

    private String wsdlUrl;
    private String connectionFactory;
    private Logger LOG = Logger.getLogger(getClass().getName());

    public void transportMessage(Object message) throws TransportException {
        TextMessage msg = (TextMessage) message;
        try {
//            Destination src = msg.getJMSReplyTo();
            String text = msg.getText();
            LOG.fine("Message Text: " + text);
//            test3ZipCodesSoapZipCodeToDetails(zip, src);
        } catch (Exception e) {
            throw new TransportException(e);
        }
    }

    public String getWsdlUrl() {
        return wsdlUrl;
    }

    public void setWsdlUrl(String wsdlUrl) {
        this.wsdlUrl = wsdlUrl;
    }

//    private void test3ZipCodesSoapZipCodeToDetails(String zip, Destination replyTo)
//            throws Exception {
//
//        com.jasongaylord.www.webservices.zipcodes.ZipCodesSoapStub binding;
//        try {
//            binding = (com.jasongaylord.www.webservices.zipcodes.ZipCodesSoapStub)
//                    new com.jasongaylord.www.webservices.zipcodes.ZipCodesLocator().getZipCodesSoap();
//        } catch (javax.xml.rpc.ServiceException jre) {
//            if (jre.getLinkedCause() != null)
//                jre.getLinkedCause().printStackTrace();
//            throw jre;
//        }
//
//        // Time out after a minute
//        binding.setTimeout(60000);
//
//        // Test operation
//        com.jasongaylord.www.webservices.zipcodes.ZipCodeToDetailsResponseZipCodeToDetailsResult value = null;
//        value = binding.zipCodeToDetails(zip);
//        String response = "Didn't get anything.";
//        if (value != null && value.get_any() != null && value.get_any().length > 0) {
//            value.get_any()[0].getAsString();
//        }
//        LOG.fine("Response: " + response);
//        //respondBack(response, replyTo);
//    }

    private void respondBack(String response, Destination replyTo) throws NamingException, JMSException {
        QueueConnection con = null;
        try {
            con = JmsUtil.getQueueConnection(connectionFactory, false);
            QueueSession ses = con.createQueueSession(false, QueueSession.AUTO_ACKNOWLEDGE);
            Message m = ses.createTextMessage(response);
            ses.createSender((Queue) replyTo).send(m);
            LOG.fine("Sent the response back to the requester.");
        } finally {
            try {
                con.close();
            } catch (Throwable ignore) {

            }
        }
    }

    public String getConnectionFactory() {
        return connectionFactory;
    }

    public void setConnectionFactory(String connectionFactory) {
        this.connectionFactory = connectionFactory;
    }
}
